<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scan_template_type".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ScanTemplateType".
 *
 * Columns in table "scan_template_type" available as properties of the model,
 * followed by relations of table "scan_template_type" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 * @property string $date_added
 * @property string $date_updated
 *
 * @property ScanTemplate[] $scanTemplates
 */
abstract class BaseScanTemplateType extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scan_template_type';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Scan Template Type|Scan Template Types', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name, date_updated', 'required'),
            array('name', 'length', 'max'=>255),
            array('date_added', 'safe'),
            array('date_added', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, name, date_added, date_updated', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'scanTemplates' => array(self::HAS_MANY, 'ScanTemplate', 'scan_template_type_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'scanTemplates' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 50)
        ));
    }

}
